implicit none
real*4, DIMENSION(:,:), ALLOCATABLE :: a ,b
real*4       :: test,therm_power,zt, efermi,diff

integer    :: i,j,nl,k,io,m
character  :: raw 
! calculate ZT an thermo power from trace

open(10, file='case.trace')
open(11, file='trace.txt')
open(12, file='testt')
open(13, file='case.infermi')

read(10,*) raw

nl=0
 DO
    READ(10,*,IOSTAT=io)  test
     IF (io > 0) THEN
      WRITE(*,*) 'Check input.  Something was wrong'
      EXIT
   ELSE IF (io < 0) THEN
     ! WRITE(*,*)  'The total is ', nl
        EXIT
   ELSE
      nl = nl+1
   END IF
END DO

close(10)

open(10, file='case.trace')
read(10,*) raw

write(*,*) 'nl',nl 

ALLOCATE(a(nl,10))		
ALLOCATE(b(nl,11))


WRITE(11,'(a,a,a)') "# (E-Ef)[eV]  T[K]               N[e/uc]             DOS(Ef)[1/(Ha*uc)]",&
& "         S[V/K]                sigma/tau0[1/(ohm*m*s)]    RH[m**3/C]             kappae/tau0[W/(m*K*s)]",&
&"    cv[J/(mol*K)]            chi[m**3/mol]                Zt                   thermo_powr"

!c zt= 5*5*6*2/8   merite figure
!c ter_power=5*5*6 power factor    

do i=1,nl
read(10,*) (a(i,j) ,j=1,10)
enddo

read(13,*) efermi

m=0

do 99 i=1,nl
 
  
  
  zt=a(i,5)*a(i,5)*a(i,6)*a(i,2)/(a(i,8))
  therm_power=a(i,5)*a(i,5)*a(i,6)
  
  diff=a(i,1)-efermi
  
  a(i,1)=diff*13.605698066
  
  
  k=i
  if(k.gt.1) then
  
    if(a(1,2).ne.a(2,2)) then
    
        if(a(k,2).eq.a(1,2)) then
        write(*,*) "Points number:", k
        write(11,*) 
     m=m+1
        endif
    else
     write(12,*) "test= ONE"
     write(12,3007) a(2,2)
    endif
  endif
   
   write(11,3005) (a(i,j), j=1,10),zt, therm_power
    
99   continue 
  
  if(m.gt.1) write(12,*) "test= MANY"
  write(*,*) "successfully calculated : zt, therm_power"
   
   
   close(10)
    close(11)
    close(12)
    close(13)

3005  FORMAT(F12.8,F10.4,F20.8,10E25.8)
3007 format("tt:", 1f10.2 )
end
	  
